// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// ADT for buffer pools using the buffer-passing style
class BufferPool {
public:
  // Return pointer to the requested block
  virtual void* getblock(int block) = 0;

  // Set the dirty bit for the buffer holding "block"
  virtual void dirtyblock(int block) = 0;

  // Tell the size of a buffer
  virtual int blocksize() = 0;
};
