// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// Sorted array-based list
// Inherit from AList as a protected base class
template <typename Key, typename Elem>
class SAList: protected AList<KVpair<Key,Elem> > {
public:
  SAList(int size=DefaultListSize) :
    AList<KVpair<Key,Elem> >(size) {}

  ~SAList() {}                    // Destructor

  // Redefine insert function to keep values sorted
  void insert(KVpair<Key,Elem>& it) { // Insert at right
    KVpair<Key,Elem> curr;
    for (movetoStart(); rightLength() > 0; next()) {
      curr = getValue();
      if(curr.key() > it.key())
        break;
    }
    AList<KVpair<Key,Elem> >::insert(it); // Do AList insert
  }

  // With the exception of append, all remaining methods are
  // exposed from AList. Append is not available to SAlist
  // class users since it has not been explicitly exposed.
  AList<KVpair<Key,Elem> >::clear;
  AList<KVpair<Key,Elem> >::remove;
  AList<KVpair<Key,Elem> >::movetoStart;
  AList<KVpair<Key,Elem> >::movetoEnd;
  AList<KVpair<Key,Elem> >::prev;
  AList<KVpair<Key,Elem> >::next;
  AList<KVpair<Key,Elem> >::leftLength;
  AList<KVpair<Key,Elem> >::rightLength;
  AList<KVpair<Key,Elem> >::movetoPos;
  AList<KVpair<Key,Elem> >::getValue;
};
