// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// Two-three tree implementation for the Dictionary ADT
template <typename Key, typename Elem>
class TTTree : public Dictionary<Key, Elem> {
private:
  TTNode<Key,Elem>* root;          // Root of the tree
  int reccount;          // Number of records stored
  // Private "helper" functions
  void clearhelp(TTNode<Key,Elem>*)                // Helper functions
    { cout << "Clearhelp not yet defined\n"; }
  void inserthelp(TTNode<Key,Elem>*&, Key, Elem,
                  Key&, Elem&, TTNode<Key,Elem>*&);
  void splitnode(TTNode<Key,Elem>*, Key, Elem,
                 TTNode<Key,Elem>*, Key&, Elem&,
                 TTNode<Key,Elem>*&);
  bool findhelp(TTNode<Key,Elem>*, Key, Elem&) const;
  void printhelp(TTNode<Key,Elem>*, int) const;

public:
  TTTree() { root = NULL; reccount = 0; }
  ~TTTree() { clearhelp(root); }

  void clear()
    { clearhelp(root);  root = NULL; reccount = 0; }

  // Insert Elem "it" with Key "k" into the dictionary.
  void insert(const Key& k, const Elem& it) {
    Elem retval;               // Smallest value in newly created node
    TTNode<Key,Elem>* retptr = NULL; // Newly created node
    Key retkey;
    inserthelp(root, k, it, retkey, retval, retptr);
    if (retptr != NULL) {      // Root overflowed: make new root
      TTNode<Key,Elem>* temp = new TTNode<Key,Elem>;
      temp->lval = retval;
      temp->lkey = retkey;
      temp->left = root;
      temp->center = retptr;
      root = temp;
    }
    reccount++;
  }

  bool remove(const Key& K, Elem& it) {
    cout << "Remove not implemented\n";
    return false;
  }

  // Remove and return the record with smallest key value
  // from the dictionary and return in "it". Return true if
  // some record is removed, false otherwise.
  Elem removeAny() {
    cout << "RemoveAny not implemented\n";
    return false;
  }

  // Return a copy in "it" of some record matching "K".
  // Return true if such exists, false otherwise. If
  // multiple records match "K", return an arbitrary one.
  bool find(const Key& K, Elem& it) const
    { return findhelp(root, K, it); }

  // Return the number of records in the dictionary.
  int size() { return reccount; }

  void print() const {
    cout << "Print tree: \n";
    if (root == NULL) cout << "The 2-3 Tree is empty.\n";
    else printhelp(root, 0);
  }
};
